// hra.cpp
#include <afxwin.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include "rc\resource.h"
#include "defines.h"
#include "Nova.h"

extern CRect rect;
extern Hra h;

Hra::Hra() {

   srand( (unsigned)time( NULL ) );
	Reset();
}

Hra::~Hra() {
	// ulozeni do registru
	AfxGetApp()->WriteProfileInt("Hra", "plochax", plochaX);
	AfxGetApp()->WriteProfileInt("Hra", "plochay", plochaY);
	AfxGetApp()->WriteProfileInt("Hra", "natahu", natahu);
	AfxGetApp()->WriteProfileInt("Hra", "pocitac", pocitac);
	AfxGetApp()->WriteProfileInt("Hra", "obtiznost_kr", obtiznost_kr);
	AfxGetApp()->WriteProfileInt("Hra", "obtiznost_ko", obtiznost_ko);
	if (autoplay == true) 	AfxGetApp()->WriteProfileInt("Hra", "autoplay", 1);
	else 	AfxGetApp()->WriteProfileInt("Hra", "autoplay", 0);
	if (demo == true) 	AfxGetApp()->WriteProfileInt("Hra", "demo", 1);
	else 	AfxGetApp()->WriteProfileInt("Hra", "demo", 0);

}

void Hra::Reset() {
	tah = 0;
// resetovani hraci plochy 
	for (int i = 0; i < PLOCHAX+17; i++)
		for (int j = 0; j < PLOCHAY+17; j++)
			pole[i][j] = NIC;
}

void Hra::NakresliVse(CDC *dc, int x, int y) {
// nakresli vsechy obrazky do brazovky
	CPoint p;
	for ( p.x = 5; p.x < plochaX+5; p.x++)
		for ( p.y = 5; p.y < plochaY+5; p.y++)
			if (pole[p.x][p.y] == KOLECKO) Kresli(dc,p,KOLECKO,x,y);
			else if (pole[p.x][p.y] == KRIZEK) Kresli(dc,p,KRIZEK,x,y);

}

void Hra::Kresli(CDC *dc, CPoint point, int co, int x, int y)
{
	CDC cdc;
	CDC cdc_b;
	
	point.x -= 5;
	point.y -= 5;

	// graficke zobrazeni : 
	CBitmap *bmp;
	CBitmap *bmp_b;
	
	bmp = new CBitmap;
	bmp_b = new CBitmap;
	
	// placnuti bitmapy
	//GetClientRect(&rect);
	cdc.CreateCompatibleDC(dc);
	cdc_b.CreateCompatibleDC(dc);
	
	CBitmap *pOB;
	CBitmap *pOB_b;

	if (co == KOLECKO) {
		bmp->LoadBitmap(IDB_KOLECKO);
		pOB = cdc.SelectObject(bmp);
		bmp_b->LoadBitmap(IDB_KOLECKO_B);
		pOB_b = cdc_b.SelectObject(bmp_b);
	}
	else if(co == KRIZEK) {
		bmp->LoadBitmap(IDB_KRIZEK);
		pOB = cdc.SelectObject(bmp);
		bmp_b->LoadBitmap(IDB_KRIZEK_B);
		pOB_b = cdc_b.SelectObject(bmp_b);
	}
	else return;
	dc->StretchBlt((point.x*x)/plochaX,
						(point.y*y)/plochaY,
						(x/plochaX),
						(y/plochaY),
						&cdc_b,0,0,9,9,SRCAND);

   dc->StretchBlt((point.x*x)/plochaX,
						(point.y*y)/plochaY,
						(x/plochaX),
						(y/plochaY),
						&cdc,0,0,9,9,SRCPAINT);

	cdc.SelectObject(pOB);
	cdc_b.SelectObject(pOB_b);

	delete bmp;
	delete bmp_b;
}

int Hra::Tahni(CDC *dc,CPoint point, int x, int y) {
	if ((point.x > plochaX+5)||(point.x < 5) || (point.y > plochaY+5) || (point.y < 5))
		return 0;
	if (pole[point.x][point.y] == NIC) pole[point.x][point.y] = natahu;
	else return 0;

	Kresli(dc,point,natahu,x,y);
	tah++;
	return 1;
}

int Hra::TestKonec(){
	int i,j;
	bool nic = false;

	for(i = 5; i < plochaX+5; i++)
		for(j = 5; j < plochaY+5; j++){
			// vertikalne
			if((NIC!=pole[i][j])&&
				(pole[i][j]==pole[i+1][j])&&
				(pole[i][j]==pole[i+2][j])&&
				(pole[i][j]==pole[i+3][j])&&
				(pole[i][j]==pole[i+4][j])) return 1;

			// horizontalne
			if((NIC!=pole[i][j])&&
				(pole[i][j]==pole[i][j+1])&&
				(pole[i][j]==pole[i][j+2])&&
				(pole[i][j]==pole[i][j+3])&&
				(pole[i][j]==pole[i][j+4])) return 1;

			// sikmo 
			if((NIC!=pole[i][j])&&
				(pole[i][j]==pole[i+1][j+1])&&
				(pole[i][j]==pole[i+2][j+2])&&
				(pole[i][j]==pole[i+3][j+3])&&
				(pole[i][j]==pole[i+4][j+4])) return 1;

			// sikmo
			if((NIC!=pole[i][j])&&
				(pole[i][j]==pole[i-1][j+1])&&
				(pole[i][j]==pole[i-2][j+2])&&
				(pole[i][j]==pole[i-3][j+3])&&
				(pole[i][j]==pole[i-4][j+4])) return 1;
	
			if (pole[i][j] == NIC) nic = true;
		};
		if ((nic = false)||(tah==plochaX*plochaY)) {
			h.natahu = NIC;
			return 1;
		};
	return 0;
}

void Hra::Init()
{
	// urcuje 1. vzhled dialogu nove hry - registry
	if ((plochaX = AfxGetApp()->GetProfileInt("Hra","plochax",-1)) == -1) 
		plochaX = 20;

	if ((plochaY = AfxGetApp()->GetProfileInt("Hra","plochay",-1)) == -1) 
		plochaY = 20;

	if ((natahu = AfxGetApp()->GetProfileInt("Hra","natahu",-1)) == -1)
		natahu = KRIZEK;

	if ((pocitac = AfxGetApp()->GetProfileInt("Hra","pocitac",-1)) == -1)
		pocitac = KOLECKO;

	if ((obtiznost_kr = AfxGetApp()->GetProfileInt("Hra","obtiznost_kr",-1)) == -1)
		obtiznost_kr = MEDIUM;

	if ((obtiznost_ko = AfxGetApp()->GetProfileInt("Hra","obtiznost_ko",-1)) == -1)
		obtiznost_ko = MEDIUM;
	
	if (AfxGetApp()->GetProfileInt("Hra","autoplay",-1) == 0) autoplay = false;
	else autoplay = true;

	if (AfxGetApp()->GetProfileInt("Hra","demo",-1) == 1) demo = true;
	else demo = false;

}
