// hra.cpp
#include <afxwin.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include "rc\resource.h"
#include "defines.h"
#include "Nova.h"
#include "cdib.h"

extern CRect rect;
extern Hra h;

Hra::Hra() {

   srand( (unsigned)time( NULL ) );
	Reset();


}

Hra::~Hra() {
	// ulozeni do registru
	AfxGetApp()->WriteProfileInt("Hra", "plochax", plochaX);
	AfxGetApp()->WriteProfileInt("Hra", "plochay", plochaY);
	AfxGetApp()->WriteProfileInt("Hra", "natahu", natahu);
	AfxGetApp()->WriteProfileInt("Hra", "pocitac", pocitac);
	AfxGetApp()->WriteProfileInt("Hra", "obtiznost_kr", obtiznost_kr);
	AfxGetApp()->WriteProfileInt("Hra", "obtiznost_ko", obtiznost_ko);
	if (autoplay == true) 	AfxGetApp()->WriteProfileInt("Hra", "autoplay", 1);
	else 	AfxGetApp()->WriteProfileInt("Hra", "autoplay", 0);
	if (demo == true) 	AfxGetApp()->WriteProfileInt("Hra", "demo", 1);
	else 	AfxGetApp()->WriteProfileInt("Hra", "demo", 0);

	delete m_pkolecko;
	delete m_pkrizek;
}

void Hra::Reset() {
	tah = 0;
// resetovani hraci plochy 
	for (int i = 0; i < PLOCHAX+17; i++)
		for (int j = 0; j < PLOCHAY+17; j++)
			if ((i < 5)||(j < 5)||(i > plochaX+4)||(j > plochaY+4)) pole[i][j] = KRAJ;
			else pole[i][j] = NIC;
}

void Hra::NakresliVse(CDC *dc, int x, int y) {
// nakresli vsechy obrazky do brazovky
	CPoint p;
	for ( p.x = 5; p.x < plochaX+5; p.x++)
		for ( p.y = 5; p.y < plochaY+5; p.y++)
			if (pole[p.x][p.y] == KOLECKO) Kresli(dc,p,KOLECKO,x,y);
			else if (pole[p.x][p.y] == KRIZEK) Kresli(dc,p,KRIZEK,x,y);

}

void Hra::Kresli(CDC *dc, CPoint point, int co, int x, int y)
{

	CDC cdc;

	point.x -= 5;
	point.y -= 5;

	// graficke zobrazeni : 
	cdc.CreateCompatibleDC(dc);
	CBitmap *pOB;

	if (co == KOLECKO) pOB = cdc.SelectObject(m_pkolecko);
	else if(co == KRIZEK) pOB = cdc.SelectObject(m_pkrizek);
		else return;
	
	dc->StretchBlt((point.x*x)/plochaX,
						(point.y*y)/plochaY,
						(x/plochaX),
						(y/plochaY),
						&cdc,size.cx,0,size.cx,size.cy,SRCAND);

   dc->StretchBlt((point.x*x)/plochaX,
						(point.y*y)/plochaY,
						(x/plochaX),
						(y/plochaY),
						&cdc,0,0,size.cx,size.cy,SRCPAINT);

	cdc.SelectObject(pOB);
}

int Hra::Tahni(CDC *dc,CPoint point, int x, int y) {
	if ((point.x > plochaX+5)||(point.x < 5) || (point.y > plochaY+5) || (point.y < 5))
		return 0;
	if (pole[point.x][point.y] == NIC) pole[point.x][point.y] = natahu;
	else return 0;

	Kresli(dc,point,natahu,x,y);
	tah++;
	return 1;
}

int Hra::TestKonec(){
	int i,j;
	bool nic = false;

	for(i = 5; i < plochaX+5; i++)
		for(j = 5; j < plochaY+5; j++){
			// vertikalne
			if((NIC!=pole[i][j])&&
				(pole[i][j]==pole[i+1][j])&&
				(pole[i][j]==pole[i+2][j])&&
				(pole[i][j]==pole[i+3][j])&&
				(pole[i][j]==pole[i+4][j])) return 1;

			// horizontalne
			if((NIC!=pole[i][j])&&
				(pole[i][j]==pole[i][j+1])&&
				(pole[i][j]==pole[i][j+2])&&
				(pole[i][j]==pole[i][j+3])&&
				(pole[i][j]==pole[i][j+4])) return 1;

			// sikmo 
			if((NIC!=pole[i][j])&&
				(pole[i][j]==pole[i+1][j+1])&&
				(pole[i][j]==pole[i+2][j+2])&&
				(pole[i][j]==pole[i+3][j+3])&&
				(pole[i][j]==pole[i+4][j+4])) return 1;

			// sikmo
			if((NIC!=pole[i][j])&&
				(pole[i][j]==pole[i-1][j+1])&&
				(pole[i][j]==pole[i-2][j+2])&&
				(pole[i][j]==pole[i-3][j+3])&&
				(pole[i][j]==pole[i-4][j+4])) return 1;
	
			if (pole[i][j] == NIC) nic = true;
		};
		if ((nic = false)||(tah==plochaX*plochaY)) {
			h.natahu = NIC;
			return 1;
		};
	return 0;
}

void Hra::Init(CDC *dc, CWnd *wnd)
{
	// urcuje 1. vzhled dialogu nove hry - registry
	if ((plochaX = AfxGetApp()->GetProfileInt("Hra","plochax",-1)) == -1) 
		plochaX = 20;

	if ((plochaY = AfxGetApp()->GetProfileInt("Hra","plochay",-1)) == -1) 
		plochaY = 20;

	if ((natahu = AfxGetApp()->GetProfileInt("Hra","natahu",-1)) == -1)
		natahu = KRIZEK;

	if ((pocitac = AfxGetApp()->GetProfileInt("Hra","pocitac",-1)) == -1)
		pocitac = KOLECKO;

	if ((obtiznost_kr = AfxGetApp()->GetProfileInt("Hra","obtiznost_kr",-1)) == -1)
		obtiznost_kr = MEDIUM;

	if ((obtiznost_ko = AfxGetApp()->GetProfileInt("Hra","obtiznost_ko",-1)) == -1)
		obtiznost_ko = MEDIUM;
	
	if (AfxGetApp()->GetProfileInt("Hra","autoplay",-1) == 0) autoplay = false;
	else autoplay = true;

	if (AfxGetApp()->GetProfileInt("Hra","demo",-1) == 1) demo = true;
	else demo = false;

	Reset();

	// ziskani bitmapy ze souboru
	CDib dib;
	if (dib.AttachMapFile("xo.bmp") == false) {
		wnd->MessageBox("Neni dostupny soubor xo.bmp !","Chyba",MB_ICONSTOP);
		exit(2);
	}	
	dib.UsePalette(dc);
	CSize sz = dib.GetDimensions();
	size.cx = sz.cx/2;
	size.cy = sz.cy/2;
	// prevedeni na DDB
	CBitmap *bmp;
	CDC cdc;
	cdc.CreateCompatibleDC(dc);
	bmp = bmp->FromHandle(dib.CreateBitmap(dc));
	CBitmap *p_cdc = cdc.SelectObject(bmp);
	// rozseknuti v polovine
	CDC cdc2;
	cdc2.CreateCompatibleDC(dc);
	m_pkolecko = new CBitmap; m_pkolecko->CreateCompatibleBitmap(dc,sz.cx,size.cy);
	m_pkrizek = new CBitmap; m_pkrizek->CreateCompatibleBitmap(dc,sz.cx,size.cy);
	CBitmap *p_cdc2 = cdc2.SelectObject(m_pkolecko);
	cdc2.BitBlt(0,0,sz.cx,size.cy,&cdc,0,0,SRCCOPY);
	cdc2.SelectObject(m_pkrizek);
	cdc2.BitBlt(0,0,sz.cx,size.cy,&cdc,0,size.cy,SRCCOPY);
	// uklid
	cdc.SelectObject(p_cdc);
	cdc2.SelectObject(p_cdc2);
	//dib.DetachMapFile();

}
