#include <afxwin.h>
#include "rc\resource.h"
#include "cdib.h"
#include "defines.h"
#include "nadpis.h"
#include "About.h"
#include "Nova.h"
#include "Mozek.h"
#include "Konec_dlg.h"
#include "Napoveda.h"

Aplikace App;
Hra h; // data cele hry
Mozek mozek;
CRect rect; // udava rozmery okna


BOOL Aplikace::InitInstance() {

	// prace s registry : 
	SetRegistryKey("Hippo Games");
	// nacteni registru hry

//	Nova ng;
//	if(ng.DoModal() == IDCANCEL)return FALSE; // nejprve zobrazi dialog nove hry
	// pote teprve vlasti okno
	m_pMainWnd = new Wokno;
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();
	return TRUE;
}

Aplikace::~Aplikace()
{
	delete m_pMainWnd;
}


BEGIN_MESSAGE_MAP(Wokno, CFrameWnd)
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_CLOSE()
	ON_COMMAND(IDM_HRA_KONEC, Konec)
	ON_COMMAND(IDM_ABOUT, _About)
	ON_COMMAND(IDM_NAPOVEDA, _Napoveda)
	ON_COMMAND(IDM_HRA_NOVA, _Nova)
	ON_COMMAND(IDM_HRA_NAS_AUTOPLAY, _AutoPlay)
	ON_UPDATE_COMMAND_UI(IDM_HRA_NAS_AUTOPLAY, _MenuUd)
	ON_COMMAND(IDM_SIT_TLUSTACARA, _Sit_Cara)
	ON_UPDATE_COMMAND_UI(IDM_SIT_TLUSTACARA, _MenuUd)


	// sit 
	ON_UPDATE_COMMAND_UI(IDM_SIT_ZADNA, _MenuUd)
	ON_COMMAND(IDM_SIT_ZADNA, _Sit_Zadna)
	ON_UPDATE_COMMAND_UI(IDM_SIT_CERNA, _MenuUd)
	ON_COMMAND(IDM_SIT_CERNA, _Sit_Cerna)
	ON_UPDATE_COMMAND_UI(IDM_SIT_BILA, _MenuUd)
	ON_COMMAND(IDM_SIT_BILA, _Sit_Bila)
	ON_UPDATE_COMMAND_UI(IDM_SIT_CERVENA, _MenuUd)
	ON_COMMAND(IDM_SIT_CERVENA, _Sit_Cervena)
	
END_MESSAGE_MAP()

Wokno::Wokno() {  // konstruktor 

// tvoreni okna
	CString str = AfxGetApp()->GetProfileString("Vzhled", "pozice");
	if (!(str.IsEmpty())) rect.SetRect(atoi((const char*) str),atoi((const char*) str + 5),
												 atoi((const char*) str + 10),atoi((const char*) str + 15));
	else rect.SetRect(0,0,400,400);
	
	Create(NULL, "Piskvorky",WS_OVERLAPPEDWINDOW,rect,NULL,NULL);
	CenterWindow(this);


// pridani menu

	CMenu menu;
	menu.LoadMenu(IDR_MENU);
	Wokno::SetMenu(&menu);
	menu.Detach();



// nastaveni ikonky
	HICON hIcon = AfxGetApp()->LoadIcon(IDI_ICON);
	SetIcon(hIcon, TRUE);

	HICON sIcon = AfxGetApp()->LoadIcon(IDI_ICON_SMALL);
	SetIcon(sIcon, FALSE);

	
		
// init plochy	
//	m_pPlocha.AttachMapFile("plocha.bmp");

	CDib dib;
	if (dib.AttachMapFile("plocha.bmp") == false){
		MessageBox("Neni dostupny soubor plocha.bmp !","Chyba",MB_ICONSTOP);
		exit(1);
	}
	CDC *dc = GetDC();
	CDC cdc;
	cdc.CreateCompatibleDC(dc);
	m_pPlocha = new CBitmap;
	dib.UsePalette(dc);
	CSize sz = dib.GetDimensions();
	velikost.cx = sz.cx;
	velikost.cy = sz.cy;
	m_pPlocha->CreateCompatibleBitmap(dc,sz.cx,sz.cy);
	CBitmap *p_cdc = cdc.SelectObject(m_pPlocha);
	dib.Draw(&cdc,CPoint(0,0),sz);
	cdc.SelectObject(p_cdc);

// aktivace site
	// urcuje, zda se zobrazi sit : 1 - cerna, 2 - bila, 3 - cervena, 0 - zadna
	if ((sit = AfxGetApp()->GetProfileInt("Vzhled", "sit",-1)) == -1) sit = 0; 
	if ((sit_size = AfxGetApp()->GetProfileInt("Vzhled", "sit_size",-1)) == -1) sit_size = 1; 

// init rectu
	GetClientRect(&rect);


	h.Init(dc,this);
	ReleaseDC(dc);

}

Wokno::~Wokno() {  // destruktor
	// zapis do registru
	WINDOWPLACEMENT wpl;
	GetWindowPlacement(&wpl);
	rect = wpl.rcNormalPosition;
	CString str;
	str.Format("%04d %04d %04d %04d",rect.left,rect.top,rect.right,rect.bottom);
	AfxGetApp()->WriteProfileString("Vzhled", "pozice",str);
	
	AfxGetApp()->WriteProfileInt("Vzhled", "sit", sit);
	AfxGetApp()->WriteProfileInt("Vzhled", "sit_size", sit_size);
	
	delete m_pPlocha;	
}

//         zpracovani zprav 

void Wokno::OnSize() {
	GetClientRect(&rect);
}

void Wokno::OnPaint() {  

	CDC *dc = GetDC(); // zjisteni dc
	
	CBitmap *pozadi;
	CDC cdc; CBitmap *pOB;
	cdc.CreateCompatibleDC(dc);


	pozadi = new CBitmap;
	pozadi->CreateCompatibleBitmap(dc,rect.Width(),rect.Height());


	pOB = cdc.SelectObject(pozadi);
	CSize size;
	size.cx = rect.Width();
	size.cy = rect.Height();
	
	// pozadi
	CDC cdc2; cdc2.CreateCompatibleDC(dc);
	CBitmap *p_cdc2 = cdc2.SelectObject(m_pPlocha);
	cdc.StretchBlt(0,0,size.cx,size.cy,&cdc2,0,0,velikost.cx,velikost.cy,SRCCOPY);
	cdc2.SelectObject(p_cdc2);

	// dokresleni X a O
	h.NakresliVse(&cdc,rect.Width(),rect.Height());
		
	// dokresleni site
	if (sit > 0) {
	// placnuti site
	//		roztazeni 1 pixelu
		int i;
		CDC cdc_s;
		CBitmap *m_black;
		m_black = new CBitmap;
	
		m_black->LoadBitmap(IDB_B);
		cdc_s.CreateCompatibleDC(dc);
		CBitmap *pOB_s = cdc_s.SelectObject(m_black);
			
		for (i = 1 ; i < h.plochaX; i++)
			cdc.StretchBlt(((i*rect.Width())/h.plochaX), 0, sit_size, rect.Height(),
										&cdc_s, sit-1 ,0,1,1,SRCCOPY);

		for (i = 1 ; i < h.plochaY; i++)
			cdc.StretchBlt(0, (i*rect.Height())/h.plochaY, rect.Width(), sit_size,
										&cdc_s, sit-1 ,0,1,1,SRCCOPY);

		cdc_s.SelectObject(pOB_s);
		delete m_black;
	};

	// plac na obrazovku
	dc->BitBlt(0,0,rect.Width(),rect.Height(),&cdc,0,0,SRCCOPY);
	cdc.SelectObject(pOB);
	ReleaseDC(dc);

	// standartni obsluha
	CFrameWnd::OnPaint();

	// nasledne uvolneni pameti
	delete pozadi;
		
	// vraceni DC
/*
	CDC *dc = GetDC(); // zjisteni dc
	
	CBitmap *pozadi;
	CDC cdc2; CBitmap *p_cdc2;
	CDC cdc; CBitmap *pOB;
	cdc.CreateCompatibleDC(dc);


	if (m_pPlocha == NULL) {
		m_pPlocha = new CBitmap;
		m_pPlocha->LoadBitmap(id_pozadi);
	};

	pozadi = new CBitmap;
	pozadi->CreateCompatibleBitmap(dc,rect.Width(),rect.Height());

	cdc2.CreateCompatibleDC(dc);

	p_cdc2 = cdc2.SelectObject(m_pPlocha);
	pOB = cdc.SelectObject(pozadi);
	cdc.StretchBlt(0,0,rect.Width(),rect.Height(),&cdc2,
						0,0,BITMAPAX,BITMAPAY,SRCCOPY);

	cdc2.SelectObject(p_cdc2);

		// dokresleni X a O
	h.NakresliVse(&cdc,rect.Width(),rect.Height());
		
	// dokresleni site
	if (sit > 0) {
	// placnuti site
	//		roztazeni 1 pixelu
		int i;
		CDC cdc_s;
		CBitmap *m_black;
		m_black = new CBitmap;
	
		m_black->LoadBitmap(IDB_B);
		cdc_s.CreateCompatibleDC(dc);
		CBitmap *pOB_s = cdc_s.SelectObject(m_black);
			
		for (i = 1 ; i < h.plochaX; i++)
			cdc.StretchBlt(((i*rect.Width())/h.plochaX), 0, sit_size, rect.Height(),
										&cdc_s, sit-1 ,0,1,1,SRCCOPY);

		for (i = 1 ; i < h.plochaY; i++)
			cdc.StretchBlt(0, (i*rect.Height())/h.plochaY, rect.Width(), sit_size,
										&cdc_s, sit-1 ,0,1,1,SRCCOPY);

		cdc_s.SelectObject(pOB_s);
		delete m_black;
	};

	// plac na obrazovku
	dc->BitBlt(0,0,rect.Width(),rect.Height(),&cdc,0,0,SRCCOPY);
	cdc.SelectObject(pOB);

	// standartni obsluha
	CFrameWnd::OnPaint();
	
	// nasledne uvolneni pameti
	delete pozadi;
		
	// vraceni DC
	ReleaseDC(dc);

*/
}

void Wokno::OnLButtonDown(UINT nFlags, CPoint point) {
	// testujeme konec hry
	if(h.TestKonec() == 1) {
		// uprava ikony
		HICON sIcon = AfxGetApp()->LoadIcon(IDI_ICON_SMALL);
		SetIcon(sIcon, FALSE);
		if (((h.demo == true)||(h.pocitac == NIC))&&((h.natahu != NIC)))	
			if (h.natahu == KRIZEK)  MessageBox("Vyhral hrac s kolecky","Konec hry!",MB_OK); 
			else  MessageBox("Vyhral hrac s Krizky","Konec hry!",MB_OK); 	
		else 
			if(h.natahu != NIC) 
				if(h.pocitac == h.natahu) MessageBox("Grrrrr","Konec hry!",MB_OK); // pocitac prohral
				else MessageBox("Cha cha cha cha cha... ","Konec hry!",MB_OK);  // pocitac vyhral
			else MessageBox("Remiza ","Konec hry!",MB_OK);

		SendMessage(WM_COMMAND,IDM_HRA_NOVA,0); // zobrazeni dialogu nove hry
		return;
	}

	// pripadne hrani pocitace
	if ((h.natahu == KRIZEK)&&(h.pocitac == KRIZEK) ||
		 (h.natahu == KOLECKO)&&(h.pocitac == KOLECKO))
		  point = mozek.Mysli();
	
	else { // kdyz hraje hrac
		GetClientRect(&rect);
		// spocitame policko, do ktereho hrac klikl a pricteme 5, protoze cele pole je posunuto o 5
		point.x = (point.x * h.plochaX) / rect.Width() + 5;
		point.y = (point.y * h.plochaY) / rect.Height() + 5;

	};
		
	CDC *dc = GetDC();
	// vlastni provedeni tahu	
	if (h.Tahni(dc,point,rect.Width(),rect.Height()) == 1) {
		// zmenime, kdo ma hrat + zmena ikony;
		HICON sIcon;
		if (h.natahu == KRIZEK) {
			h.natahu = KOLECKO;
			sIcon = AfxGetApp()->LoadIcon(IDI_KOLECKO);
		}
		else {
			h.natahu = KRIZEK;
			sIcon = AfxGetApp()->LoadIcon(IDI_KRIZEK);
		};
		SetIcon(sIcon, FALSE);
	};
	ReleaseDC(dc);

	CString s;
	s.Format("Piskvorky - %d. tah",h.tah);
	SetWindowText(s);

	// uprava pri demu
	if (h.demo == true) h.pocitac = h.natahu;

	// pripadne hrani pocitace
	if (((h.natahu == KRIZEK)&&(h.pocitac == KRIZEK) ||
		 (h.natahu == KOLECKO)&&(h.pocitac == KOLECKO)) &&
		 (h.autoplay == true)) {
		// zparacovani ostatnich zprav
		MSG msg;
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)){
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		};
		PostMessage(WM_LBUTTONDOWN); 
	};

}

void Wokno::Konec() {
	SendMessage(WM_CLOSE,0,0);
}

void Wokno::_About() { // okno about
	About(this).DoModal();
}

void Wokno::_Napoveda() { // okno napovedy
	Napoveda(this).DoModal();
}

void Wokno::_Nova() {  // init nove hry
	Nova dlg(this);

	// prekresleni obrazovky
	if (dlg.DoModal() == IDOK) {
		SetWindowText("Piskvorky");
		SendMessage(WM_PAINT,0,0);
	}

}

void Wokno::_MenuUd(CCmdUI* pCmd) {
	switch(pCmd->m_nID) {
	
	case IDM_HRA_NAS_AUTOPLAY : {
				if (h.pocitac==NIC) pCmd ->Enable(FALSE);
		else {
			if (h.autoplay == false) pCmd->SetCheck(FALSE);
			else pCmd->SetCheck(TRUE);
			pCmd->Enable(TRUE);
		};
		break;
										 };
		case IDM_SIT_TLUSTACARA : {
		if (sit_size == 2) pCmd->SetCheck(TRUE);
		else  pCmd->SetCheck(FALSE);
		break;
							 };
// site :
	case IDM_SIT_ZADNA : {
		if (sit == 0) pCmd->SetCheck(TRUE);
		else  pCmd->SetCheck(FALSE);
		break;
							 };
	case IDM_SIT_CERNA : {
		if (sit == 1) pCmd->SetCheck(TRUE);
		else  pCmd->SetCheck(FALSE);
		break;
							 };
	case IDM_SIT_BILA : {
		if (sit == 2) pCmd->SetCheck(TRUE);
		else  pCmd->SetCheck(FALSE);
		break;
							 };
	case IDM_SIT_CERVENA : {
		if (sit == 3) pCmd->SetCheck(TRUE);
		else  pCmd->SetCheck(FALSE);
		break;
							 };
	};
	
}



void Wokno::_AutoPlay(){
	if (h.autoplay == true) h.autoplay = false;
	else h.autoplay = true;

	SendMessage(WM_PAINT,0,0);
}

void Wokno::OnClose() {

	Konec_dlg dlg(this);
	
	if (dlg.DoModal() == IDOK)
		if (h.natahu == NIC) SendMessage(WM_COMMAND,IDM_HRA_NOVA,0);
		else {
			PostMessage(WM_QUIT,0,0);
			//CFrameWnd::OnClose();
		};
}



//          Site 

void Wokno::_Sit_Zadna() {
	if (sit == 0) return;
	sit = 0;
	SendMessage(WM_PAINT,0,0);
}

void Wokno::_Sit_Cerna() {
	if (sit == 1) return;
	sit = 1;
	SendMessage(WM_PAINT,0,0);
}

void Wokno::_Sit_Bila() {
	if (sit == 2) return;
	sit = 2;
	SendMessage(WM_PAINT,0,0);
}

void Wokno::_Sit_Cervena() {
	if (sit == 3) return;
	sit = 3;
	SendMessage(WM_PAINT,0,0);
}

void Wokno::_Sit_Cara() {
	if (sit_size == 1) sit_size = 2;
	else sit_size = 1;
	SendMessage(WM_PAINT,0,0);
}
